/* Declaracoes de render.cc */



class CRender {

public:

	CRender ();

protected:

	float m_afPrj [ MAXZ - MINZ + 1 ]; // tabela interna com Z projetado

	CGr m_oGr;                          // funcoes graficas de video
	CSolido* m_poS;                     // objeto a ser renderisado

	INT16 m_nIX;     // componente x do vetor de iluminacao
	INT16 m_nIY;     // componente y do vetor de iluminacao
	INT16 m_nIZ;     // componente z do vetor de iluminacao
	INT16 m_nNX;     // componente x do vetor normal ao poligono em teste
	INT16 m_nNY;     // componente y do vetor normal ao poligono em teste
	INT16 m_nNZ;     // componente z do vetor normal ao poligono em teste
	float m_fModI;   // modulo (comprimento) do vetor de iluminacao
	float m_fModV;   // modulo do vetor normal ao poligono em teste
   // tabelas de vertices projetados e transladados
   INT16* m_panX2D;            // componentes x dos vertices do solido
   INT16* m_panY2D;            // componentes y dos vertices do solido

	BYTE mRetSupVisivel ();
	INT16 mRetCorP ( UINT16 uPol );
	INT16 mRetCorN ( UINT16 uPol );
	INT16 mRetCorZ ( UINT16 uPol );

public:

	void mAtrIlum ( INT16 nVX, INT16 nVY, INT16 nVZ );
   void mAtrObjeto ( CSolido &oS );
	void mRenderPixels ( INT nTX, INT nTY, BYTE yCor );
	void mRenderPoligonos ( INT nTX, INT nTY );
};